/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: Stream.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#ifndef OpenSOAP_Stream_H
#define OpenSOAP_Stream_H

#include <OpenSOAP/ByteArray.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

    typedef struct tagOpenSOAPStream OpenSOAPStream;
    typedef OpenSOAPStream    *OpenSOAPStreamPtr;
    
    int
    OPENSOAP_API
    OpenSOAPStreamRelease(OpenSOAPStreamPtr /* [in, out] */ s);
    
    int
    OPENSOAP_API
    OpenSOAPStreamRead(OpenSOAPStreamPtr /* [in] */ s,
                       unsigned char * /* [out] */ buf,
                       size_t * /* [in, out] */ buf_sz);
    

    int
    OPENSOAP_API
    OpenSOAPStreamWrite(OpenSOAPStreamPtr /* [in] */ s,
                        const unsigned char * /* [in] */ buf,
                        size_t * /* [in, out] */ buf_sz);
    

    int
    OPENSOAP_API
    OpenSOAPStreamReadToDelm(OpenSOAPStreamPtr /* [in] */ s,
                             const unsigned char * /* [in] */ delm,
                             size_t /* [in] */ delm_sz,
                             OpenSOAPByteArrayPtr /* [out] */ buf);
    
    int
    OPENSOAP_API
    OpenSOAPStreamReadWithSize(OpenSOAPStreamPtr /* [in] */ s,
                               size_t /* [in] */ sz,
                               OpenSOAPByteArrayPtr /* [out] */ buf);

    int
    OPENSOAP_API
    OpenSOAPStreamWriteByteArray(OpenSOAPStreamPtr /* [in] */ s,
                                 OpenSOAPByteArrayPtr /* [in] */ buf,
                                 size_t * /* [out] */ write_sz);
    
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OpenSOAP_Stream_H */
