# -----------------------------------------------------------------------------
#  $RCSfile: Calc.mak,v $
# 
#  See Copyright for the status of this software.
# 
#  The OpenSOAP Project
#  http://opensoap.jp/
# -----------------------------------------------------------------------------
#
#
#

PROGRAMS = CalcClient CalcService CalcService.cgi

OPENSOAP_PREFIX=/usr/local
OPENSOAP_INCLUDE=$(OPENSOAP_PREFIX)/include
OPENSOAP_LIB=$(OPENSOAP_PREFIX)/lib

XML2_LIBS=`xml2-config --libs`

CFLAGS=-I$(OPENSOAP_INCLUDE)
CGI_CFLAGS=$(CFLAGS) -DCONNECT_TYPE=\"cgi\"
COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -Wl,-rpath -Wl,$(OPENSOAP_LIB)
#COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -R$(OPENSOAP_LIB)
CLIENT_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPClient
SERVICE_LDFLAGS=$(CLIENT_LDFLAGS) -lOpenSOAPService

SOURCES= CalcClient.c CalcService.c
OBJS=$(SOURCES:.c=.o) CalcService.cgi.o

all: $(PROGRAMS)

CalcService.cgi.o: CalcService.c
	$(CC) $(CGI_CFLAGS) -c -o $@ $<

CalcClient: CalcClient.o
	$(CC)  -o $@ $^ $(CLIENT_LDFLAGS) $(XML2_LIBS)

CalcService: CalcService.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS) $(XML2_LIBS)

CalcService.cgi: CalcService.cgi.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS) $(XML2_LIBS)

clean: 
	rm -f $(OBJS) $(PROGRAMS)
