/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: SOAPMessage.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef SOAP_MESSAGE_H_
#define SOAP_MESSAGE_H_

#include <string>
#include <vector>

extern
std::string
createSOAPFaultMessage (std::string faultcodeStr, std::string faultstringStr,
			std::string faultactorStr, std::string detailStr);

extern
bool
extractOperationAndParam (std::string soapMsg,
			  std::vector<std::string>& operationNames,
			  std::vector<std::string>& paramNames,
			  std::vector<std::string>& paramValues);

/*
  Messaage ID ł邩ׂB
 */
extern
bool
isItMsgID(const std::string soapMsg, bool& itIsMsgID);

/*
  E񓯊 TTL Ɋւׂ
 */
extern
bool
getAsyncInfoFromHeader(const std::string soapMsg, 
		       bool& asyncHeaderExist, bool& isAsync);

/*
  ]Ɋւׂ
*/
extern
bool
getFwdInfoFromHeader(const std::string soapMsg,
		     bool& fwdPathExist, std::vector<std::string>& fwdPath,
		     bool& hopCountExist, unsigned int& hopCount);
/*
  Received Path Ɋւ𒲂ׂ
*/
bool
getReceivedPathInfo(const string soapMsg, 
		    bool& receivedPathExist, 
		    std::vector<std::string>& receivedPath);

/*
  TTL Ɋւׂ
 */
extern
bool
getTTLInfo(const std::string soapMsg,
	   bool& ttlHeaderExist, unsigned int& ttl, std::string& ttlType);

// SOAPbZ[W烁bZ[W ID ̕oB
extern
std::string
getMsgIDContent(const std::string soapMsg);


//----- Iy[V^CAEgƂ Fault bZ[W쐬 -----//
extern
std::string
makeTimeoutMessage();

//----- Iy[VȂƂ Fault bZ[W쐬 -----//
extern
std::string
makeOperationNotFoundMessage();


//----- SOAP NGXgsłƂ Fault bZ[W쐬 -----//
extern
std::string
makeInvalidRequestMessage();

//----- create Falut Messgage of No Entry -----//
extern
std::string
makeNoEntryMessage();

//----- SOAP bZ[WɃbZ[W ID tƂ -----//
//----- bZ[W ID Ԃ -----//
//----- MsgDrv Ŏgp -----//
extern
std::string
attachMsgID(std::string& soapMsg, const std::string& fileIDOfMsgFromIf,
	    const std::string& operationName);

//----- SOAP bZ[WɃbZ[W ID tƂ -----//
//----- bZ[W ID Ԃ -----//
//----- SrvDrv Ŏgp -----//
extern
std::string
attachOrUpdateMsgID(std::string& soapMsg, std::string msgIDContent);

//----- SOAP bZ[W received_path t -----//
extern
bool
attachReceivedPath(std::string& soapMsg, 
		   const std::string& fileIDOfMsgFromIf,
		   const std::string& url);

//----- SOAP bZ[W backward_path tEXV -----//
extern
bool
updateBackwardPath(std::string& soapMsg, 
		   const std::string& backwardURL);

//----- SOAP bZ[WɃbZ[W ID t -----//
//----- T[rXŎgp -----//
extern
bool
attachMsgID(std::string& soapMsg, const std::string& msgIDContent);

// NGXg SOAP bZ[WÃT[o[
// bZ[W̍ŏIł邩𔻒fB
bool
isItAsyncFwdFinalReceiver(std::string soapMsg,
			  std::string soapServerEndPoint);

/*
  backward_path Ɋւׂ
*/
bool
getBackwardPath(const std::string& soapMsg, std::string& backwardPath);


// bZ[WX|Xǂ𔻒f
// MsgDrv, Forwarder g
extern
bool
isItResponseMessage(std::string soapMsg);

//----- Service ƒʐMƂ߂̃wb_t -----//
std::string
attachHeaderForService(std::string soapMsg);

//----- Service ƒʐMƂ߂̃wb_폜 -----//
std::string
removeHeaderForService(std::string soapMsg);

//----- SrvDrv ƒʐMƂ߂̃wb_t -----//
std::string
attachHeaderForSrvDrv(std::string soapMsg);

//----- FQDN t̃zXgԂ -----//
std::string
getLocalhostName();

#endif  SOAP_MESSAGE_H_
