/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: Timeout.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef _Timeout_H_
#define _Timeout_H_

#include <pthread.h>

namespace OpenSOAP {

  class Timeout {
  public:
    Timeout(int timeout_second);
    Timeout(int timeout_second, pthread_t thr_id);
    ~Timeout();

  public:
    void setTargetThread(pthread_t thr_t);
    void setTimeout(int timeout_second);

    //^C}[ĎJn(ΏۏJnO ďo)
    int start();

    //^C}[ĎI(ΏۏI ďo)
    int finish();

    // ^[QbgXbhLZĂ邩H
    bool targetThreadIsCanceled();
    
    //private:
  protected:
    bool isRunning_;    
    bool targetThreadIsCanceled_;
    int timeoutSecond_;
    pthread_t targetThread_;
    pthread_t timerThr_id_;
    pthread_mutex_t isRunning_mutex_;
    
    void initMutex();
    void destroyMutex();
    static void* runTimeout(void* arg);
  };
}

#endif _Timeout_H_


