/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: XmlModifier.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef _XmlModifier_H_
#define _XmlModifier_H_

#include <string>
#include <vector>
#include <libxml/tree.h>
//#include <parser.h>

namespace OpenSOAP {
  
  class XmlModifier {

  public:
    typedef struct NameSpaceDefTag {
      std::string href;
      std::string prefix;
    } NameSpaceDef;

  public:
    XmlModifier(const std::string& xmlMsg);
    virtual ~XmlModifier();

    //not use namespace
    int attach(const std::string& fmt, const std::string& value);
    //use namespace
    int attach(const std::string& fmt, const std::string& value,
	       const NameSpaceDef* nsDef);
    //fmt : "/Envelope/Header/opensoap-header-block/message_id=?"
    //value : "12345"
    //nsDef : NULL = parent node ns use

    int update(const std::string& fmt, const std::string& value);

    //output XMLmessage
    std::string toString();

    //void spy() const;

    //not test
    int append(const std::string& fmt, const std::string& value);
    //use namespace
    int append(const std::string& fmt, const std::string& value,
	       const NameSpaceDef* nsDef);

  protected:

    xmlDocPtr xmlDoc;
  };

} // end of namespace OpenSOAP


#endif _XmlModifier_H_
